#include "cscore.h"                                   /*   CSCOREMAIN.C   */

extern void scfopen(int, char **), cscorinit(void), cscore(void);
extern void lput(EVLIST *);
extern FILE *oscfp;

main(int argc, char **argv)	/* cscore stub to run a user prog standalone   */
{
	scfopen(argc,argv);     /* open the command line scorein file */
	cscorinit();
	cscore();               /* and call the user cscore program   */
}

void lplay(EVLIST *a)		/* for standalone cscore: no full Csound, so */
				/*  field lplay calls & put events to stderr */
{
	FILE *osave;

        err_printf(
	    "cscore lplay:  full Csound would now play the following score\n");
        osave = oscfp;
	oscfp = stderr;
	lput(a);
	oscfp = osave;
}

/* This standalone cscore stub is invoked with cscore_xxx.c as follows:    */
/*       cc -o cscore cscore_xxx.c -lcscore                                */
/* or, if no libcscore.a was created at installation:                      */
/*       cc -o cscore cscore_xxx.c $CSOUND/cscoremain.o $CSOUND/cscorefns.o \
/*                       $CSOUND/rdscor.o $CSOUND/memalloc.o           	   */
/* where CSOUND is an environment variable denoting a Csound directory     */
/* containing previously compiled modules.                                 */
/* If can't find cscore.h use -I/usr/local/include, or copy from Csound    */
/* The resulting executable can be run with:				   */
/*       cscore scorin > scoreout			        	   */


